<apex:page controller="cms.CreateContentController" extensions="DSP_CMS_ContactController" showHeader="false" sidebar="false" cache="false" standardStylesheets="false">
    <script type="text/javascript">
        $(document).ready(function()
                          {
                              ce.content_editor('registerSaveFunction', function()
                                                                        {
                                                                            users = users2JSON();

                                                                            responsibleFor = responsibleFor2JSON();
                                                                            
                                                                            var attributes = new Array();
                                                                            
                                                                            attributes.push({"name":"anchor","value":$('#anchor').val(),"type":"text"});
                                                                            attributes.push({"name":"name","value":$('#name').val(),"type":"text"});
                                                                            attributes.push({"name":"description","value":$('#description').val(),"type":"text"});
                                                                            attributes.push({"name":"users","value":users,"type":"text"});
                                                                            attributes.push({"name":"responsibleFor","value":responsibleFor,"type":"text"});
                                                                            
                                                                            return attributes;
                                                                        }
                                               );
                              JSON2users('{!users}');
                              JSON2responsibleFor('{!responsibleFor}');
                          }
        );
        
        function users2JSON()
        {
            var jsonString = '{"users":[';
            $('#users div').each(function()
                             {
                                 jsonString += '{';
                                 jsonString += '"name":"'+$(this).children("input[name='name']").val()+'",';
                                 jsonString += '"role":"'+$(this).children("input[name='role']").val()+'",';
                                 jsonString += '"email":"'+$(this).children("input[name='email']").val()+'",';
                                 jsonString += '"phone":"'+$(this).children("input[name='phone']").val()+'"';
                                 jsonString += '},';
                             });
            jsonString = jsonString.slice(0, -1);
            jsonString += ']}';
            
            return jsonString;
        }
        
        function responsibleFor2JSON()
        {
            var jsonString = '{"responsibleFors":[';
            $('#responsiblefor div').each(function()
                             {
                                 jsonString += '"'+$(this).children("input:nth-child(1)").val()+'",';
                             });
            jsonString = jsonString.slice(0, -1);
            jsonString += ']}';
            
            return jsonString;
        }
        
        function JSON2users(userString)
        {
            var userList = JSON.parse(userString);
            $.each(userList.users, function()
                                   {
                                       addNewUser($(this).get('0').name, $(this).get('0').role, $(this).get('0').email, $(this).get('0').phone);
                                   });
        }
        
        function JSON2responsibleFor(responsibleForString)
        {
            var responsibleForList = JSON.parse(responsibleForString);
            $.each(responsibleForList.responsibleFors, function()
                                       {
                                           addNewResponsibleFor($(this).get(0));
                                       });
        }
        
        function addNewUser(name,role,email,phone)
        {
            $('#users').append('<div style="border:1px solid #AAA;margin-left:2em">Name: <input type="text" name="name" value="'+name+'"/><br/>Role: <input type="text" name="role" value="'+role+'"/><br/>Email: <input type="text" name="email" value="'+email+'"/><br/>Phone: <input type="text" name="phone" value="'+phone+'"/><br/><input type="button" value="-" onclick="removeUser(this);"/></div>');
        }
        
        function removeUser(element)
        {
            $(element).parent().remove();
        }
        
        function addNewResponsibleFor(name)
        {
            $('#responsiblefor').append('<div style="border:1px solid #AAA;margin-left:2em"><input type="text" value="'+name+'"/><input type="button" value="-" onclick="removeResponsibleFor(this);"/></div>');
        }
        
        function removeResponsibleFor(element)
        {
            $(element).parent().remove();
        }
    </script>
    <h1>Edit Contact</h1>
    <table>
        <tr>
            <td>Anchor: </td>
            <td>
                <input type="text" name="anchor" id="anchor" value="{!anchor}"/>
            </td>
        </tr>
        <tr>
            <td>Name: </td>
            <td>
                <input type="text" name="name" id="name" value="{!name}"/>
            </td>
        </tr>
        <tr>
            <td>Description: </td>
            <td>
                <input type="text" name="description" id="description" value="{!description}"/>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <div>Users:</div>
                <div id="users"></div>
                <div>
                    <input type="button" value="+" onclick="addNewUser('','','','');"/>
                </div>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <div>Responsible For:</div>
                <div id="responsiblefor"></div>
                <div>
                    <input type="button" value="+" onclick="addNewResponsibleFor('');"/>
                </div>
            </td>
        </tr>
    </table>
</apex:page>